import tkinter as tk
from tkinter import ttk
from tkinter import *
from tkinter import messagebox
from tkinter import PhotoImage
import socket
conection = False


def stop(Event):
    try:
        server.send(bytes([ord(' ')]))
    except BrokenPipeError:
        messagebox.showwarning("Lo siento","Intentelo Nuevamente")

def Up(Event):
    try:
        server.send(bytes([ord('w')]))
    except BrokenPipeError:
        messagebox.showwarning("Lo siento","Intentelo Nuevamente")
    
def Down(Event):
    try:
        server.send(bytes([ord('s')]))
    except BrokenPipeError:
        messagebox.showwarning("Lo siento","Intentelo Nuevamente")
    
def Left(Event):
    try:
        server.send(bytes([ord('a')]))
    except BrokenPipeError:
        messagebox.showwarning("Lo siento","Intentelo Nuevamente")

def Right(Event):
    try:
        server.send(bytes([ord('d')]))
    except BrokenPipeError:
        messagebox.showwarning("Lo siento","Intentelo Nuevamente")

def Shoot():
    try: 
        if (angle.get() == 45):
            server.send(bytes([ord('1')]))
        elif (angle.get() == 60):
            server.send(bytes([ord('2')]))
        elif (angle.get() == 90):
            server.send(bytes([ord('3')]))

    except BrokenPipeError:
        messagebox.showwarning("Lo siento","Intentelo Nuevamente")
        
def Disconnect():
    if conection:
        server.send(bytes([ord('z')]))
        ventana.destroy()
    else:
        ventana.destroy()

    
def Power(value):
    if (value == 45):
        angle.set(value)
    elif (value == 60):
        angle.set(value)
    elif (value == 90):
        angle.set(value)
    else:
        messagebox.showwarning("¡Error!","Ángulo no asignado")
    

def Validar():
    pts = 0
    numero = True
    for k in ip.get():
        if (k == '.'):
            pts += 1
        elif (k.isdigit()):
            continue
        else:
            numero = False
    if (pts == 3 and numero):
        conectar()
    else:
        messagebox.showwarning("Error","Ingrese una dirección valida")
    ip.set("")


def conectar():
    puerto = 4999
    direccion = ip.get()
    try: 
        server.connect((direccion,puerto))
        messagebox.showinfo("Conectado","Se ha establecido la conexion exitosamente")
        conection = True
        entrada_IP.config(state=DISABLED)
    except BrokenPipeError:
        messagebox.showwarning("Desconectado","Ingrese la dirección correcta")
        conection = False
    ip.set("")

# Ventana principal
ventana = tk.Tk()
ventana.geometry("750x500") 
ventana.title("Machine EV3")
ventana.configure(bg="light sea green")  
ventana.resizable(0,0)

ip = StringVar()
angle = IntVar()
angle.set(0)

# Ingresar Imagenes
up = PhotoImage(file="up.png")
down = PhotoImage(file="down.png")
left = PhotoImage(file="left.png")
right = PhotoImage(file="right.png")
cross = PhotoImage(file="cross.png")

# Dimensiones de las Imagenes
up = up.subsample(6, 6)
down = down.subsample(6, 6)
left = left.subsample(6, 6)
right = right.subsample(6, 6)
cross = cross.subsample(6, 6)

# Iniciar Servidor
server = socket.socket()

# Boton Arriba
boton_arriba = Button(None, repeatdelay=20,repeatinterval=20,text="UP", command= lambda:[Up(None)], background="cadetblue2", image=up)
boton_arriba.place(x=150, y=105)

ventana.bind('<KeyPress-w>',Up)
ventana.bind('<KeyRelease-w>',stop)

# Boton Derecha
boton_derech = Button(None, repeatdelay=20,repeatinterval=20 ,text="RIGHT", command= lambda:[Right(None)], background="cadetblue2", image=right)
boton_derech.place(x=260, y=215)

ventana.bind('<KeyPress-d>',Right)
ventana.bind('<KeyRelease-d>',stop)

# Boton Izquierda
boton_izq = Button(None, repeatdelay=20,repeatinterval=20, text="LEFT", command= lambda:[Left(None)], background="cadetblue2", image=left)
boton_izq.place(x=40, y=215)

ventana.bind('<KeyPress-a>',Left)
ventana.bind('<KeyRelease-a>',stop)

# Boton Abajo
boton_abajo = Button(None, repeatdelay=20, repeatinterval=20,text="DOWN", command= lambda:[Down(None)], background="cadetblue2", image=down)
boton_abajo.place(x=150, y=325)

ventana.bind('<KeyPress-s>',Down)
ventana.bind('<KeyRelease-s>',stop)

# Boton Disparar
boton_disparar = Button(text="SHOT", command = Shoot, background="cadetblue2", image=cross)
boton_disparar.place(x=515, y=270)

# Boton Power de 45°
boton_p45 = Button(text="Angle 45%", command=lambda:Power(45), background="cadetblue2",fg = "DodgerBlue4")
boton_p45.config(width=7, height=4)
boton_p45.place(x=410, y=220)

# Boton Power de 60°
boton_p60 = Button(text="Angle 60%", command=lambda:Power(60), background="cadetblue2",fg = "DodgerBlue4")
boton_p60.config(width=7, height=4)
boton_p60.place(x=520, y=160)

# Boton potenca de 90°
boton_p90 = Button(text="Angle 90%", command=lambda:Power(90), background="cadetblue2",fg = "DodgerBlue4")
boton_p90.config(width=7, height=4)
boton_p90.place(x=630, y=220)

# Desconectar Brick
boton_exit = Button(text="Shutdown",command = Disconnect,background="cadetblue2",fg = "DodgerBlue4")
boton_exit.config(width=9, height=1)
boton_exit.place(x=620, y=20)

#Ingreso ip
entrada_IP = Entry(ventana,textvariable = ip, width = 18)
entrada_IP.focus_set()
entrada_IP.place(x = 320, y=25)

# Conexión
boton_conectar = Button(text="Conect",background="cadetblue2",fg = "DodgerBlue4",command = Validar)
boton_conectar.config(width=9, height=1)
boton_conectar.place(x=490, y=20)

# Detener Motores
boton_arriba.bind('<ButtonRelease-1>',stop)
boton_abajo.bind('<ButtonRelease-1>',stop)
boton_izq.bind('<ButtonRelease-1>',stop)
boton_derech.bind('<ButtonRelease-1>',stop)

ventana.mainloop()


